#include <LedControl.h>
#include "images.h"

const int DIN = 0;
const int CS =  1;
const int CLK = 2;
LedControl display=LedControl(DIN, CLK, CS, 1);

byte buffer[8];

const int IMAGES_LEN = sizeof(IMAGES) / 8 - 1;

unsigned long previousMillis = 0;
const long interval = 150;

void setup() {
  display.clearDisplay(0);
  display.shutdown(0, false);
  display.setIntensity(0, 15);
}

// Flips the bytes around otherwise image is mirrored for some reason
byte flipByte(byte c){
  c = ((c>>1)&0x55)|((c<<1)&0xAA);
  c = ((c>>2)&0x33)|((c<<2)&0xCC);
  c = (c>>4) | (c<<4);
  return c;
}


void displayImage() {
  for (int i = 0; i < 8; i++) {
    byte row = (flipByte(buffer[i]));
    for (int j = 0; j < 8; j++) {
      display.setLed(0, i, j, bitRead(row, j));
    }
  }
}


int i = 0;
void loop() {  
  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis >= interval) {
    previousMillis = currentMillis;
    memcpy_P(buffer, IMAGES[i] + 8, 8);
    displayImage();
  
    if (i++ >= IMAGES_LEN ) {
      i = 0;
      display.clearDisplay(0);
    }
  }
  
}
